<%@ Page Language="VB" Debug="true" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server">

    Dim ConnectionString As String
    Dim SelectCommand As String

    Dim isEditing As Boolean = False

    Sub Page_Load(Sender As Object, E As EventArgs)

        connectionstring = application("cs")
        selectcommand = "SELECT  rid,toemail,subject, msg,senddate from reminders where uid = " & session("uid")

        If Not Page.IsPostBack Then

            ' Databind the data grid on the first request only
            ' (on postback, bind only in editing, paging and sorting commands)

            BindGrid()

        End If

    End Sub

    Sub DataGrid_ItemCommand(Sender As Object, E As DataGridCommandEventArgs)

        ' this event fires prior to all of the other commands
        ' use it to provide a more graceful transition out of edit mode

        CheckIsEditing(e.CommandName)

    End Sub

    Sub CheckIsEditing(commandName As String)

        If DataGrid1.EditItemIndex <> -1 Then

            ' we are currently editing a row
            If commandName <> "Cancel" And commandName <> "Update" Then

                ' user's edit changes (If any) will not be committed
                Message.Text = "Your changes have not been saved yet.  Please press update to save your changes, or cancel to discard your changes, before selecting another item."
                isEditing = True

            End If

        End If

    End Sub

    Sub DataGrid_Edit(Sender As Object, E As DataGridCommandEventArgs)

        ' turn on editing for the selected row

        If Not isEditing Then

            DataGrid1.EditItemIndex = e.Item.ItemIndex
            BindGrid()

        End If

    End Sub

    Sub DataGrid_Update(Sender As Object, E As DataGridCommandEventArgs)

        ' update the database with the new values

        ' get the edit text boxes
        Dim rid As String = datagrid1.datakeys(e.item.itemindex)
        Dim toemail As String = CType(e.Item.Cells(3).Controls(0), TextBox).Text
        Dim subject As String = CType(e.Item.Cells(4).Controls(0), TextBox).Text
        Dim msg As String = CType(e.Item.Cells(5).Controls(0), TextBox).Text
        Dim senddate As String = CType(e.Item.Cells(6).Controls(0), TextBox).Text

        ' TODO: update the Command value for your application
        Dim myConnection As New SqlConnection(ConnectionString)
        Dim UpdateCommand As SqlCommand = new SqlCommand()
        UpdateCommand.Connection = myConnection

        If AddingNew = True Then
            UpdateCommand.CommandText = "INSERT INTO reminders VALUES (@rid, @uid, @toemail, @senddate,getdate(),@msg,@subject)"
        Else
            UpdateCommand.CommandText = "UPDATE reminders SET toemail = @toemail, msg = @msg WHERE rid = @rid"
        End If

        UpdateCommand.Parameters.Add("@uid", SqlDbType.int).Value = session("uid")
        UpdateCommand.Parameters.Add("@rid", SqlDbType.int).Value = rid
        UpdateCommand.Parameters.Add("@senddate", SqlDbType.VarChar,20).Value = senddate
        UpdateCommand.Parameters.Add("@toemail", SqlDbType.VarChar, 30).Value = toemail
        UpdateCommand.Parameters.Add("@subject", SqlDbType.VarChar, 30).Value = subject
        UpdateCommand.Parameters.Add("@msg", SqlDbType.VarChar, 30).Value = msg


        ' execute the command
        Try
            myConnection.Open()
            UpdateCommand.ExecuteNonQuery()

        Catch ex as Exception
            Message.Text = ex.ToString()

        Finally
            myConnection.Close()

        End Try

        ' Resort the grid for new records
        If AddingNew = True Then
            DataGrid1.CurrentPageIndex = 0
            AddingNew = false
        End If

        ' rebind the grid
        DataGrid1.EditItemIndex = -1
        BindGrid()

    End Sub

    Sub DataGrid_Cancel(Sender As Object, E As DataGridCommandEventArgs)

        ' cancel editing

        DataGrid1.EditItemIndex = -1
        BindGrid()

        AddingNew = False

    End Sub

    Sub DataGrid_Delete(Sender As Object, E As DataGridCommandEventArgs)

        ' delete the selected row

        If Not isEditing Then


            Dim keyValue As String = DataGrid1.DataKeys(e.Item.ItemIndex)

            Dim myConnection As New SqlConnection(ConnectionString)
            Dim DeleteCommand As New SqlCommand("DELETE from reminders where rid=" & keyValue, myConnection)


            myConnection.Open()
            DeleteCommand.ExecuteNonQuery()
            myConnection.Close()

            ' rebind the grid
            DataGrid1.CurrentPageIndex = 0
            DataGrid1.EditItemIndex = -1
            BindGrid()

        End If

    End Sub

    Sub DataGrid_Page(Sender As Object, E As DataGridPageChangedEventArgs)

        ' display a new page of data

        If Not isEditing Then

            DataGrid1.EditItemIndex = -1
            DataGrid1.CurrentPageIndex = e.NewPageIndex
            BindGrid()

        End If

    End Sub

    Sub AddNew_Click(Sender As Object, E As EventArgs)

        ' add a new row to the end of the data, and set editing mode 'on'

        CheckIsEditing("")

        If Not isEditing = True Then

            ' set the flag so we know to do an insert at Update time
            AddingNew = True

            ' add new row to the end of the dataset after binding

            ' first get the data
            Dim myConnection As New SqlConnection(ConnectionString)
            Dim myCommand As New SqlDataAdapter(SelectCommand, myConnection)

            Dim ds As New DataSet()
            myCommand.Fill(ds)

            ' add a new blank row to the end of the data
            Dim rowValues As Object() = {"0", "", "","","1/1/2003"}
            ds.Tables(0).Rows.Add(rowValues)

            ' figure out the EditItemIndex, last record on last page
            Dim recordCount As Integer = ds.Tables(0).Rows.Count

            If recordCount > 1 Then

                recordCount -= 1
                DataGrid1.CurrentPageIndex = recordCount \ DataGrid1.PageSize
                DataGrid1.EditItemIndex = recordCount Mod DataGrid1.PageSize

            End If

            ' databind
            DataGrid1.DataSource = ds
            DataGrid1.DataBind()

        End If


    End Sub

    ' ---------------------------------------------------------------
    '
    ' Helpers Methods:
    '

    ' property to keep track of whether we are adding a new record,
    ' and save it in viewstate between postbacks

    Property AddingNew() As Boolean

        Get
            Dim o As Object = ViewState("AddingNew")
            If o Is Nothing Then
                Return False
            End If
            Return CBool(o)
        End Get

        Set(ByVal Value As Boolean)
            ViewState("AddingNew") = Value
        End Set

    End Property

    Sub BindGrid()

        Dim myConnection As New SqlConnection(ConnectionString)
        Dim myCommand As New SqlDataAdapter(SelectCommand, myConnection)

        Dim ds As New DataSet()
        myCommand.Fill(ds)

        DataGrid1.DataSource = ds
        DataGrid1.DataBind()

    End Sub

</script>
<html>
<head>
</head>
<body style="FONT-FAMILY: arial">
    <h2>Updation Of Reminders
    </h2>
    <hr size="1" />
    <form runat="server">
        <asp:datagrid id="DataGrid1" runat="server" DataKeyField="rid" OnItemCommand="DataGrid_ItemCommand" OnEditCommand="DataGrid_Edit" OnUpdateCommand="DataGrid_Update" OnCancelCommand="DataGrid_Cancel" OnDeleteCommand="DataGrid_Delete" AllowPaging="True" PageSize="6" OnPageIndexChanged="DataGrid_Page" ForeColor="Black" BackColor="White" CellPadding="3" GridLines="None" CellSpacing="1" width="100%" AutoGenerateColumns="False">
            <FooterStyle backcolor="#C6C3C6"></FooterStyle>
            <HeaderStyle font-bold="True" forecolor="White" backcolor="#4A3C8C"></HeaderStyle>
            <PagerStyle font-size="Smaller" horizontalalign="Right" backcolor="#C6C3C6" mode="NumericPages"></PagerStyle>
            <ItemStyle font-size="10pt" font-names="Verdana" backcolor="#DEDFDE"></ItemStyle>
            <Columns>
                <asp:EditCommandColumn ButtonType="LinkButton" UpdateText="Update" CancelText="Cancel" EditText="Edit">
                    <ItemStyle font-size="Smaller" width="10%"></ItemStyle>
                </asp:EditCommandColumn>
                <asp:ButtonColumn Text="Delete" CommandName="Delete">
                    <ItemStyle font-size="Smaller" width="10%"></ItemStyle>
                </asp:ButtonColumn>
                <asp:BoundColumn DataField="rid" ReadOnly="True" HeaderText="Rid"></asp:BoundColumn>
                <asp:BoundColumn DataField="toemail" HeaderText="To Email"></asp:BoundColumn>
                <asp:BoundColumn DataField="subject" HeaderText="Subject"></asp:BoundColumn>
                <asp:BoundColumn DataField="msg" HeaderText="Message"></asp:BoundColumn>
                <asp:BoundColumn DataField="senddate" HeaderText="Send Date"></asp:BoundColumn>
            </Columns>
        </asp:datagrid>
        <br />
        <asp:LinkButton id="LinkButton1" onclick="AddNew_Click" runat="server" Text="Add new item" Font-Size="smaller"></asp:LinkButton>
        &nbsp;&nbsp;
        <a  href="default.aspx">Menu </a>
        <br />
        <br />
        <asp:Label id="Message" runat="server" width="80%" forecolor="red" enableviewstate="false"></asp:Label>
    </form>
</body>
</html>
